<template>
  <div class="wrapper">
    <h1>Погода</h1>
    <p>Узнай погоду в {{ city == "" ? "вашем городе" : cityName }}</p>
    <input type="text" v-model="city" placeholder="Введите город" />
    <button @click="getWeather()">Узнать погоду</button>
    <p class="error">{{ error }}</p>
    <div v-if="shouldShowWeather">
      <p>{{ showTemp }}</p>
      <p>{{ showFeelsLike }}</p>
      <p>{{ showMinTemp }}</p>
      <p>{{ showMaxTemp }}</p>
    </div>
  </div>
</template>

<script>
import axios from "axios";
export default {
  data() {
    return {
      city: "",
      error: "",
      info: null,
    };
  },
  computed: {
    cityName() {
      return "<<" + this.city + ">>";
    },
    shouldShowWeather() {
      if (this.city == "") {
        this.info = null;
      }
      return this.info !== null;
    },
    showTemp() {
      return "Температура: " + this.info.main.temp;
    },
    showFeelsLike() {
      return "Ощущается как: " + this.info.main.feels_like;
    },
    showMinTemp() {
      return "Минимальная температура: " + this.info.main.temp_min;
    },
    showMaxTemp() {
      return "Максимальная температура: " + this.info.main.temp_max;
    },
  },
  methods: {
    getWeather() {
      if (this.city.trim().length < 2) {
        this.error = "Нужно название более одного символа";
        return false;
      }
      this.error = "";
      this.clearWeatherInfo();
      axios
        .get(
          `https://api.openweathermap.org/data/2.5/weather?q=${this.city}&units=metric&appid=de5189debc9c5776c2bb961007310413`
        )
        .then((res) => (this.info = res.data));
    },
    clearWeatherInfo() {
      if (this.city == "") {
        this.info = null;
      }
    },
  },
};
</script>

<style scoped>
.error {
  color: red;
}
.wrapper {
  width: 900px;
  height: 500px;
  border-radius: 50px;
  background: rgb(27, 24, 24);
  padding: 20px;
  color: white;
  text-align: center;
}

.wrapper h1 {
  margin-top: 50px;
}

.wrapper p {
  margin-top: 20px;
}

.wrapper input {
  margin-top: 30px;
  background: transparent;
  border-bottom: 2px solid rgb(38, 37, 37);
  color: #cbc9c9;
  font-size: 14px;
  padding: 5px 8px;
}

.wrapper input:focus {
  border-bottom-color: rgb(146, 192, 76);
}

.wrapper button {
  background: rgb(223, 238, 174);
  background: radial-gradient(
    circle,
    rgba(223, 238, 174, 1) 0%,
    rgba(183, 217, 118, 1) 100%
  );
  color: #090909;
  border-radius: 10px;
  border: 2px solid rgb(223, 238, 174);
  padding: 10px 15px;
  margin-left: 20px;
  cursor: pointer;
  transition: transform 500ms ease;
  font-weight: 600;
}

.wrapper button:hover {
  transform: scale(1.1) translateY(-5px);
}
</style>
